/* Configuration.
 *
 * Skeleton configurable module (c) 2005 PegSoft
 * Contact us at pegsoft@pegsoft.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file COPYING); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <system/headers.h>

#include "conf.h"

using namespace std;

/*************************************************************************/

namespace skelconf
{

/*************************************************************************/

/* We use this macro to add directives to the configuration parser, so that
 * we don't have to repeat the same thing over and over again. */

#define CHECK_ADD(x, y, z) if (!(x).add((z))) { \
	(y).errorf("Can't add directive %s: out of memory?", (z).name().c_str()); \
	return false; }

/*************************************************************************/

/* The constructor initializes the directive "example" to be named example,
 * with a false default value, and sets it as reloadable.
 *
 * See the API documentation for more information ;) */

Directives::Directives(conf::ConfLogger &logger) : DirectivesQ(logger),
		example("example", false, true)
{
	
}

/*************************************************************************/

/* This function adds the directive example to the configuration parser. */

bool Directives::add(conf::Conf &conf)
{
	CHECK_ADD(conf, conf, example);
	
	return true;
}

/*************************************************************************/

} /* namespace skelconf */

/*************************************************************************/
