/* Configuration.
 *
 * Skeleton configurable module (c) 2005 PegSoft
 * Contact us at pegsoft@pegsoft.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file COPYING); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef CONF_H
#define CONF_H

/*************************************************************************/

#include <conf/directives.h>
#include <conf/quick.h>

/*************************************************************************/
	
namespace skelconf 
{

/*************************************************************************/

/// The encapsulating class for directives.

/** To build efficiently a class that can prepare a configuration parser
  * and initialize the configurations directives all at once, we create
  * a class derived from conf::DirectivesQ.
  *
  * The constructor initializes the directives, while the add() function
  * adds them to a specified configuration parser. It's that simple! */

class Directives : public conf::DirectivesQ
{
	public:
		/* Classes */
		
		/* Add any custom directive classes you need here ;) */
		
		/* Data */
		
		/// An example directive.
		conf::ConfBool example;
		
		/* Functions */ 
		
		/// Constructor -- initializes the directives.
		Directives(conf::ConfLogger &logger);
		
		/// Adds the directives to the given parser.
		bool add(conf::Conf &conf);
	private:
		Directives(Directives const &d);
		Directives &operator=(Directives const &right);
};

/*************************************************************************/

} /* namespace skelconf */

/*************************************************************************/

#endif /* CONF_H */
